import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.registry.LocateRegistry;

// Simple clock server
//
public class ClockServer extends UnicastRemoteObject implements RemoteClock
{
	private SynchronizedClock clock;

	// Constructor
	public ClockServer() throws RemoteException
	{
		clock = new SynchronizedClock();
	}

	// Remote method: read the server time
	public long getTime() throws RemoteException
	{
		return clock.getTime();
	}

	// Start registry, create server, and register it.
	public static void main(String args[])
	{
		try {
			System.out.println("create ClockServer");
			ClockServer remObj = new ClockServer();

			System.out.println("starting Registry");
			LocateRegistry.createRegistry(1099);

			System.out.println("binding ClockServer");
			Naming.rebind("ClockServer", remObj);

			System.out.println("-- server ready, waiting for clients --");
		}
		catch(Exception ex) {
			ex.printStackTrace();
		}
	}
}
